#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

static char **parse_path(const char *path) {
    while ( *path == '/' ) path++;      // skip leading '/'
    // First pass: identify, null terminate, and count separators
    int seps = 1;                       // separator count (1: first item)
    int arrsize = 1;                    // array size (1: first item)
    char *save = strdup(path);          // make copy we can modify
    char *s = save;
    while ( ( s = strchr(s, '/') ) ) {
        while ( *s == '/' ) { *s++ = 0; seps++; }
        if ( *s ) { arrsize++; }
    }
    arrsize++;                          // (room for terminating NULL)
    // Second pass: create array, save nonblank elements
    char **arr = (char**)malloc(sizeof(char*) * arrsize);
    int t = 0;
    s = save;
    while ( seps-- > 0 ) {
        if ( *s ) { arr[t++] = s; }     // skips empty fields, eg. '//'
        s += (strlen(s) + 1);
    }
    arr[t] = 0;
    return(arr);
}

int main(){
    printf("START\n");
    char **arr = parse_path("");
    printf("LOOP\n");
    for ( int t=0; arr[t]; t++ )
        printf("arr[%d]='%s'\n", arr[t]);
    printf("DONE\n");
}
